/****************************************************************************/
/**   vjboxd  Startup-Code - wird einmal beim Programmstart aufgerufen     **/
/**                                                                        **/
/** Copyright (C) 1997 Jochen Tillmann-Sarrazin, DG6VJ                     **/
/** All rights reserved.                                                   **/
/****************************************************************************/



#include "global.h"



/* Konfigurations-File einlesen.
 * Rckgabe: 0, wenn OK, -1 wenn Fehler
 * Informationen ber den Fehler wird auf die Standardausgabe geschrieben.
 */
int read_vjboxd_conf()
{
  char tmp[500],data[500];
  FILE *f;
  int i,found,line=0,error=0;
  
  
  mycall[0] = '\0';
  myhierarch[0] = '\0';
  boxroot[0] = '\0';
  sfinfo[0] = '\0';
  boxport = 0;
  stdlt = -1;
  userlt = -1;
  
  
  
  strcpy(tmp,"vjboxd.conf");
  if ((f = fopen(tmp,"r")) == NULL) {
    printf("vjboxd.conf is not available.\n");
    _exit(10);
  }
  
  while (fgets(tmp,499,f) != NULL) {
    line++;
    
    if (tmp[0] != '#') {
      if ((i = POS('\n',tmp)) != -1) tmp[i] = '\0';
      if ((i = POS('\r',tmp)) != -1) tmp[i] = '\0';
      
      if ((i = POS(' ',tmp)) != -1) {
        COPY(data,tmp,i+1,strlen(tmp)-i-1);
        tmp[i] = '\0';
        
        found = 0;
        if (!found && (!strcmp(tmp,"mycall"))) {
          found = 1;
          data[9] = '\0';
          strcpy(mycall,data);
        }
        if (!found && (!strcmp(tmp,"hierarch"))) {
          if (data[0] != '.') {
            printf("Line %i: First char of the hierarch-field *must* be a point!",line);
          }
          else {
            found = 1;
            data[49] = '\0';
            strcpy(myhierarch,data);
          }
        }
        if (!found && (!strcmp(tmp,"boxdir"))) {
          found = 1;
          data[99] = '\0';
          strcpy(boxroot,data);
        }
        if (!found && (!strcmp(tmp,"sfinfo"))) {
          found = 1;
          data[20] = '\0';
          strcpy(sfinfo,data);
        }
        if (!found && (!strcmp(tmp,"port"))) {
          found = 1;
          boxport = atoi(data);
        }
        if (!found && (!strcmp(tmp,"stdlt"))) {
          found = 1;
          stdlt = atoi(data);
        }
        if (!found && (!strcmp(tmp,"userlt"))) {
          found = 1;
          userlt = atoi(data);
        }
        if (!found && (!strcmp(tmp,"thirdparty"))) {
          found = 1;
          if (data[1] != '\0') {
            printf("Line %i: Wrong parameter (%s) for keyword %s\n",line,data,tmp);
            error = 1;
          }
          else {
            switch (data[0]) {
              case 'j': myflags &= MY_THIRDPARTY; break;
              case 'y': myflags &= MY_THIRDPARTY; break;
              case 'n': break;
              default: printf("Line %i: Wrong parameter (%s) for keyword %s\n",line,data,tmp);
                       error = 1;
            }
          }
        }
        
        
        if (!found) {
          printf("Line %i: Unknown keyword %s.\n",line,tmp);
          error = 1;
        }
      }
    }
  }
  
  if (mycall[0] == '\0') {
    printf("mycall - Line missing in vjboxd.conf!\n");
    error = 1;
  }
  if (boxroot[0] == '\0') {
    printf("boxdir - Line missing in vjboxd.conf!\n");
    error = 1;
  }
  if (boxport == 0) {
    printf("boxport - Line missing in vjboxd.conf!\n");
    error = 1;
  }
  if (stdlt == -1) {
    printf("stdlt - Line missing in vjboxd.conf!\n");
    error = 1;
  }
  if (stdlt > 999) {
    printf("stdlt - Line must be between 0 and 999!\n");
    error = 1;
  }
  if (userlt == -1) {
    printf("userlt - Line missing in vjboxd.conf!\n");
    error = 1;
  }
  if (userlt > 999) {
    printf("userlt - Line must be between 0 and 999!\n");
    error = 1;
  }
  
  fclose(f);
  
  if (error) _exit(10);
 
}



/* Legt alle ntigen Verzeichnisse an. */
void make_directories()
{
  char tmp[500];
  int fd;
  
  sprintf(tmp,"%s/index",boxroot);
  if (mkdir(tmp,448) == -1) { }
  
  sprintf(tmp,"%s/info",boxroot);
  if (mkdir(tmp,448) == -1) { }
  
  sprintf(tmp,"%s/system",boxroot);
  if (mkdir(tmp,448) == -1) { }
  
  sprintf(tmp,"%s/user",boxroot);
  if (mkdir(tmp,448) == -1) { }
  
  sprintf(tmp,"%s/userdata",boxroot);
  if (mkdir(tmp,448) == -1) { }

  sprintf(tmp,"%s/log",boxroot);
  if (mkdir(tmp,448) == -1) { }
  
  sprintf(tmp,"%s/sfqueue",boxroot);
  if (mkdir(tmp,448) == -1) { }
}



/* Irgendwelche globalen Variablen initialisieren */
void init_globals()
{
  startuptime = time(NULL);
  myflags = 0;
}



void init_syslogd()
{
    openlog("vjboxd",LOG_PID,LOG_LOCAL0);
}



void read_boards_box()
{
  s_boards *tmp;
  FILE *fs;
  int i,k,lt,maxlt,error=FALSE,line=0,fd;
  char strtmp[500],strtmp2[100],rubrik[9],rubrik_after[9];

  boardsroot = NULL;

  sprintf(strtmp,"%s/system/boards.box",boxroot);
  if ((fd = open(strtmp,O_RDONLY)) == -1) return; 

  if ((fs = fdopen(fd,"r")) == NULL) {
    close(fd);
    return;
  }

  /* File locken */
  lockit(fd,F_RDLCK,0,SEEK_SET,0);

  while (fgets(strtmp,100,fs) != NULL) {
    line++;
    if (strtmp[0] != '#') {
      if ((i = POS(' ',strtmp)) == -1) {
        printf("Error in line %i.\n",line);
        error = TRUE;
      }
      else {
        k = i;
        if (k > 8) k = 8;
        COPY(rubrik,strtmp,0,k);
        COPY(strtmp,strtmp,i+1,strlen(strtmp)-i-1);
        if ((i = POS(' ',strtmp)) == -1) {
          printf("Error in line %i.\n",line);
          error = TRUE;
        }
        else {
          k = i;
          if (k > 8) k = 8;
          COPY(rubrik_after,strtmp,0,k);
          COPY(strtmp,strtmp,i+1,strlen(strtmp)-i-1);
          if ((i = POS(' ',strtmp)) == -1) {
            printf("Error in line %i.\n",line);
            error = TRUE;
          }
          else {
            COPY(strtmp2,strtmp,0,k);
            COPY(strtmp,strtmp,i+1,strlen(strtmp)-i-1);
          
            if ((lt = atoi(strtmp)) == 0) {
              printf("Error in line %i: wrong lifetime!\n",line);
              error = TRUE;
            }
            else if ((maxlt = atoi(strtmp2)) == 0) {
                   printf("Error in line %i: wrong lifetime!\n",line);
                   error = TRUE;
                 }
          }
        }
      }
      if (!error) {
        /* Eintrag in der Liste vornehmen */
        tmp = boardsroot;
      
        if (tmp == NULL) {
          tmp = (s_boards *)malloc(sizeof(s_boards));
          boardsroot = tmp;
        }
        else {
          while (tmp->next != NULL) tmp = tmp->next;
          tmp->next = (s_boards *)malloc(sizeof(s_boards));
          tmp = tmp->next;
        }
        tmp->next = NULL;
        strcpy(tmp->rubrik,rubrik);
        strcpy(tmp->rubrik_after,rubrik_after);
        tmp->lifetime = lt;
        tmp->lifetime_max = maxlt;
      }
    }
  }
  
  /* File unlocken */
  lockit(fd,F_UNLCK,0,SEEK_SET,0);
  
  close(fd);
  
  if (error) _exit(9);
}



/* Den Speicher fr diese verkettete Liste wieder freigeben */
void close_boards_box()
{
  s_boards *tmp;
  
  while (boardsroot != NULL) {
    tmp = boardsroot;
    boardsroot = boardsroot->next;
    free(tmp);
  }
}



/* Inhalt des Files system/reject.box */
void read_reject_box()
{
  char str[500],strtmp[500],absender[9],verteiler[9],empfaenger[9];
  int fd,i,count,was,typ,maxsize,err=0,line=0;
  FILE *fs;
  s_reject *tmp;

  rejectroot = NULL;

  
  sprintf(strtmp,"%s/system/reject.box",boxroot);
  if ((fd = open(strtmp,O_RDONLY)) == -1) return; 


  if ((fs = fdopen(fd,"r")) == NULL) {
    close(fd);
    return;
  }

  /* File locken */
  lockit(fd,F_RDLCK,0,SEEK_SET,0);

  while ((fgets(strtmp,100,fs) != NULL) && (!err)) {
    line++;
  
    if ((i = POS('\n',strtmp)) != -1) strtmp[i] = '\0';
    if ((i = POS('\r',strtmp)) != -1) strtmp[i] = '\0';
  
    if ((strtmp[0] != '#') && (strtmp[0] != '\0')) {
      /* Alle TABs in SPACEs umwandeln */
      count = strlen(strtmp);
      i = 0;
      while (i < count) {
        if (strtmp[i] == 9) strtmp[i] = ' ';
        i++;
      }
    
      OnlyOneSpace(str,strtmp);
      err = 0;
    
      /* Operation */
      if ((i = POS(' ',str)) != -1) {
        COPY(strtmp,str,0,i);
        COPY(str,str,i+1,strlen(str)-i-1);
      
        switch (upcase(strtmp[0])) {
          case 'R': was = 1; break;
          case 'H': was = 2; break;
          case 'L': was = 3; break;
          case 'P': was = 4; break;
          default: err = 1;
        }
      }
      else err = 1;
    
    
      /* Typ */
      if ((i = POS(' ',str)) != -1) {
        COPY(strtmp,str,0,i);
        COPY(str,str,i+1,strlen(str)-i-1);
      
        switch (upcase(strtmp[0])) {
          case 'B': typ = 1; break;
          case 'P': typ = 2; break;
          default: err = 1;
        }
      }
      else err = 1;


      /* Absender */
      if ((i = POS(' ',str)) != -1) {
        COPY(strtmp,str,0,i);
        COPY(str,str,i+1,strlen(str)-i-1);
      
        strtmp[9] = '\0';
        strcpy(absender,strtmp);
      }
      else err = 1;


      /* Verteiler */
      if ((i = POS(' ',str)) != -1) {
        COPY(strtmp,str,0,i);
        COPY(str,str,i+1,strlen(str)-i-1);
      
        strtmp[9] = '\0';
        strcpy(verteiler,strtmp);
      }
      else err = 1;


      /* Empfaengerr */
      if ((i = POS(' ',str)) != -1) {
        COPY(strtmp,str,0,i);
        COPY(str,str,i+1,strlen(str)-i-1);
      
        strtmp[9] = '\0';
        strcpy(empfaenger,strtmp);
      }
      else err = 1;


      /* Maximale Gre */
      maxsize = atoi(str);



      if (err) printf("Error in system/reject.box line %i!\n",line);
      else {
        /* Kein Fehler - diesen Eintrag wirklich eintragen */
        tmp = rejectroot;
      
        if (tmp == NULL) {
          tmp = (s_reject *)malloc(sizeof(s_reject));
          rejectroot = tmp;
        }
        else {
          while (tmp->next != NULL) tmp = tmp->next;
          tmp->next = (s_reject *)malloc(sizeof(s_reject));
          tmp = tmp->next;
        }
        tmp->next = NULL;
        tmp->was = was;
        tmp->typ = typ;
        Klein(absender);
        strcpy(tmp->absender,absender);
        Klein(verteiler);
        strcpy(tmp->verteiler,verteiler);
        Klein(empfaenger);
        strcpy(tmp->empfaenger,empfaenger);
        tmp->maxsize = maxsize;
      }

    
    }
  }
  
  /* File unlocken */
  lockit(fd,F_UNLCK,0,SEEK_SET,0);
  
  close(fd);
  
  if (err) _exit(14);
}




/* Den Speicher fr diese verkettete Liste wieder freigeben */
void close_reject_box()
{
  s_reject *tmp;
  
  while (rejectroot != NULL) {
    tmp = rejectroot;
    rejectroot = rejectroot->next;
    free(tmp);
  }
}



void read_server_box()
{
  s_server *tmp;
  FILE *fs;
  char str[500],str2[500];
  int line,i,error;

  serverroot = NULL;
  
  sprintf(str,"%s/system/server.box",boxroot); 
  if ((fs = fopen(str,"r")) == NULL) return;
  
  line = 0;
  while (fgets(str,100,fs) != NULL) {
    line++;
    if (str[0] != '#') {
      KillSpacesLeft(str);
      if (str[0] != '\0') {
        KillSpacesRight(str);
        
        if ((i = POS(' ',str)) != -1) {
          COPY(str2,str,0,i);
          COPY(str,str,i+1,strlen(str)-i-1);
          Klein(str2);
          
          /* Sooo... neuer Eintrag in die Liste */
          tmp = serverroot;
      
          if (tmp == NULL) {
            tmp = (s_server *)malloc(sizeof(s_server));
            serverroot = tmp;
          }
          else {
            while (tmp->next != NULL) tmp = tmp->next;
            tmp->next = (s_server *)malloc(sizeof(s_server));
            tmp = tmp->next;
          }
          tmp->next = NULL;
          strcpy(tmp->rub,str2);		/* Rubrik */
          tmp->filename = (char *)strdup(str);	/* Verzeichnis+Programmname des Servers */
        }
        else printf("Error in system/server.box line %i!\n",line);
      }
    }
  }
  
  fclose(fs);
}



/* Den Speicher fr diese verkettete Liste wieder freigeben */
void close_server_box()
{
  s_server *tmp;
  
  while (serverroot != NULL) {
    tmp = serverroot;
    serverroot = serverroot->next;
    free(tmp);
  }
}



/* Einen FIFO erstellen, in den die einzelnen Instanzen die BIDs 'reinschreiben, die neu 'reingekommen
 * sind.
 */
void make_bidfifo()
{
  char tmp[500];
  
  sprintf(tmp,"%s/bidfifo",boxroot);
  mkfifo(tmp,S_IRUSR|S_IWUSR);
  
  if ((bidfifofd = open(tmp,O_WRONLY)) == -1)
  {
    printf("ERROR! Cannot open bid-fifo (%s).\n",strerror(errno));
    printf("       Filename: %s\n\n",tmp);
    exit(1);
  }
}


